PipeWire: node.c File Reference

PipeWire 0.2.2

Functions
node.c File Reference
Include dependency graph for node.c:

## Functions
int | pw_node_update_ports (struct pw_node *node)
int | pw_node_register (struct pw_node *this, struct pw_client *owner, struct pw_global *parent, struct pw_properties *properties)
| Complete initialization of the node and register. More...
struct pw_node * | pw_node_new (struct pw_core *core, const char *name, struct pw_properties *properties, size_t user_data_size)
const struct pw_node_info * | pw_node_get_info (struct pw_node *node)
| Get the node info. More...
void * | pw_node_get_user_data (struct pw_node *node)
| Get node user_data. More...
struct pw_core * | pw_node_get_core (struct pw_node *node)
| Get the core of this node. More...
struct pw_global * | pw_node_get_global (struct pw_node *node)
| Get the global of this node. More...
const struct pw_properties * | pw_node_get_properties (struct pw_node *node)
| Get the node properties. More...
int | pw_node_update_properties (struct pw_node *node, const struct spa_dict *dict)
| Update the node properties. More...
void | pw_node_set_implementation (struct pw_node *node, struct spa_node *spa_node)
| Set the node implementation. More...
struct spa_node * | pw_node_get_implementation (struct pw_node *node)
| Get the node implementation. More...
void | pw_node_add_listener (struct pw_node *node, struct spa_hook *listener, const struct pw_node_events *events, void *data)
| Add an event listener. More...
int | pw_node_for_each_port (struct pw_node *node, enum pw_direction direction, int(*callback)(void *data, struct pw_port *port), void *data)
| Iterate the ports in the given direction. More...
int | pw_node_for_each_param (struct pw_node *node, uint32_t param_id, uint32_t index, uint32_t max, const struct spa_pod *filter, int(*callback)(void *data, uint32_t id, uint32_t index, uint32_t next, struct spa_pod *param), void *data)
struct pw_port * | pw_node_find_port (struct pw_node *node, enum pw_direction direction, uint32_t port_id)
| Find the port with direction and port_id or NULL when not found. More...
uint32_t | pw_node_get_free_port_id (struct pw_node *node, enum pw_direction direction)
| Get a free unused port_id from the node. More...
int | pw_node_set_active (struct pw_node *node, bool active)
| Set a node active. More...
bool | pw_node_is_active (struct pw_node *node)
| Check if a node is active. More...
int | pw_node_set_enabled (struct pw_node *node, bool enabled)
| Set a node enabled. More...
bool | pw_node_is_enabled (struct pw_node *node)
| Check if a node is enabled. More...

## Function Documentation

## ◆ pw_node_add_listener()

void pw_node_add_listener | ( | struct pw_node * | node,
|  | struct spa_hook * | listener,
|  | const struct pw_node_events * | events,
|  | void * | data
| ) |  |

Add an event listener.

## ◆ pw_node_find_port()

struct pw_port* pw_node_find_port | ( | struct pw_node * | node,
|  | enum pw_direction | direction,
|  | uint32_t | port_id
| ) |  |

Find the port with direction and port_id or NULL when not found.

References PW_DIRECTION_INPUT, and pw_map::pw_map_lookup().

## ◆ pw_node_for_each_param()

int pw_node_for_each_param | ( | struct pw_node * | node,
|  | uint32_t | param_id,
|  | uint32_t | index,
|  | uint32_t | max,
|  | const struct spa_pod * | filter,
|  | int(*)(void *data, uint32_t id, uint32_t index, uint32_t next, struct spa_pod *param) | callback,
|  | void * | data
| ) |  |

## ◆ pw_node_for_each_port()

int pw_node_for_each_port | ( | struct pw_node * | node,
|  | enum pw_direction | direction,
|  | int(*)(void *data, struct pw_port *port) | callback,
|  | void * | data
| ) |  |

Iterate the ports in the given direction.

The callback should return 0 to fetch the next item, any other value stops the iteration and returns the value. When all callbacks return 0, this function returns 0 when all items are iterated.

References PW_DIRECTION_INPUT.

## ◆ pw_node_get_core()

struct pw_core* pw_node_get_core | ( | struct pw_node * | node | ) |

Get the core of this node.

## ◆ pw_node_get_free_port_id()

uint32_t pw_node_get_free_port_id | ( | struct pw_node * | node,
|  | enum pw_direction | direction
| ) |  |

Get a free unused port_id from the node.

References PW_DIRECTION_INPUT, and pw_map::pw_map_insert_new().

## ◆ pw_node_get_global()

struct pw_global* pw_node_get_global | ( | struct pw_node * | node | ) |

Get the global of this node.

## ◆ pw_node_get_implementation()

struct spa_node* pw_node_get_implementation | ( | struct pw_node * | node | ) |

Get the node implementation.

## ◆ pw_node_get_info()

const struct pw_node_info* pw_node_get_info | ( | struct pw_node * | node | ) |

Get the node info.

## ◆ pw_node_get_properties()

const struct pw_properties* pw_node_get_properties | ( | struct pw_node * | node | ) |

Get the node properties.

## ◆ pw_node_get_user_data()

void* pw_node_get_user_data | ( | struct pw_node * | node | ) |

Get node user_data.

The size of the memory was given in pw_node_new

## ◆ pw_node_is_active()

bool pw_node_is_active | ( | struct pw_node * | node | ) |

Check if a node is active.

## ◆ pw_node_is_enabled()

bool pw_node_is_enabled | ( | struct pw_node * | node | ) |

Check if a node is enabled.

## ◆ pw_node_new()

struct pw_node* pw_node_new | ( | struct pw_core * | core,
|  | const char * | name,
|  | struct pw_properties * | properties,
|  | size_t | user_data_size
| ) |  |

References pw_log::pw_log_debug(), pw_properties::pw_properties_new(), and impl::this.

## ◆ pw_node_register()

int pw_node_register | ( | struct pw_node * | this,
|  | struct pw_client * | owner,
|  | struct pw_global * | parent,
|  | struct pw_properties * | properties
| ) |  |

Complete initialization of the node and register.

Parameters

  this | node to register
  owner | optional owner
  parent | optional parent
  properties | extra properties

References pw_log::pw_log_debug(), pw_loop_invoke, pw_node_update_ports(), and pw_properties::pw_properties_new().

## ◆ pw_node_set_active()

int pw_node_set_active | ( | struct pw_node * | node,
|  | bool | active
| ) |  |

Set a node active.

This will start negotiation with all linked active nodes and start data transport

References pw_log::pw_log_debug().

## ◆ pw_node_set_enabled()

int pw_node_set_enabled | ( | struct pw_node * | node,
|  | bool | enabled
| ) |  |

Set a node enabled.

The node will be able to be activated

References pw_log::pw_log_debug().

## ◆ pw_node_set_implementation()

void pw_node_set_implementation | ( | struct pw_node * | node,
|  | struct spa_node * | spa_node
| ) |  |

Set the node implementation.

## ◆ pw_node_update_ports()

int pw_node_update_ports | ( | struct pw_node * | node | ) |

References pw_log::pw_log_debug(), PW_NODE_CHANGE_MASK_INPUT_PORTS, and PW_NODE_CHANGE_MASK_OUTPUT_PORTS.

Referenced by pw_node_register().

## ◆ pw_node_update_properties()

int pw_node_update_properties | ( | struct pw_node * | node,
|  | const struct spa_dict * | dict
| ) |  |

Update the node properties.

References pw_properties::pw_properties_set().